/* (c) https://github.com/MontiCore/monticore */
/* generated by template templates.de.monticore.lang.montiarc.tagschema.ValuedTagType*/


package nfp.LatencyTagSchema;

import de.monticore.lang.montiarc.tagging._symboltable.TagKind;
import de.monticore.lang.montiarc.tagging._symboltable.TagSymbol;

import org.jscience.physics.amount.Amount;
import javax.measure.quantity.Duration;
import javax.measure.unit.Unit;

/**
 * Created by ValuedTagType.ftl
 */
public class LatencyCmpInstSymbol extends TagSymbol {
  public static final LatencyCmpInstKind KIND = LatencyCmpInstKind.INSTANCE;

  public LatencyCmpInstSymbol(Amount<Duration> value) {
    this(KIND, value);
  }

  public LatencyCmpInstSymbol(Number number, Unit<Duration> unit) {
    this(KIND, number, unit);
  }

  protected LatencyCmpInstSymbol(LatencyCmpInstKind kind, Amount<Duration> value) {
    super(kind, value);
  }

  protected LatencyCmpInstSymbol(LatencyCmpInstKind kind, Number number, Unit<Duration> unit) {
    this(kind, number.toString().contains(".") ?
      Amount.valueOf(number.doubleValue(), unit) :
      Amount.valueOf(number.intValue(),
          unit));
  }

  public Amount<Duration> getValue() {
     return getValue(0);
  }

  public Number getNumber() {
    return getValue().getExactValue();
  }

  public Unit<Duration> getUnit() {
    return getValue().getUnit();
  }

  @Override
  public String toString() {
    return String.format("LatencyCmpInst = %s %s",
      getNumber(), getUnit());
  }

  public static class LatencyCmpInstKind extends TagKind {
    public static final LatencyCmpInstKind INSTANCE = new LatencyCmpInstKind();

    protected LatencyCmpInstKind() {
    }
  }
}
